from Tkinter import *
import serial
import time
root = Tk() #Makes the window
root.wm_title("Serial LED") #Makes the title that will appear in the top left
root.config(background = "#FFFFFF") #sets background color to white
#A. Widgets Begin
#1.Frame and its contents
Frame1 = Frame(root, width=400, height = 600) #creates a frame widget of size 400x600
Frame1.grid(row=0, column=0, padx=0, pady=0)  #Places the widget on row 0 of root grid.

firstLabel = Label(Frame1, text="Physical Status of LED") #creates a label widget inside Frame1
firstLabel.grid(row=0, column=0, padx=10, pady=2)         #Places the label widget on row 0 of Frame1 grid

#2.Canvas for drawing rectangles when the LED is toggled.
rectCanvas = Canvas(Frame1, width=100, height=100, bg='white') #Creates a canvas widget inside Frame1
rectCanvas.grid(row=1, column=0, padx=10, pady=10)             #Places the canvas widget on row 1 of Frame1 grid

#3. Label on top of the Buttons
secondLabel = Label(Frame1, text="Click the Buttons")       #creates a second label widget inside Frame1
secondLabel.grid(row=2, column=0, padx=10, pady=2)          #Places the label widget on row 2 of Frame1 grid

#4. Frame for placing the Buttons
btnFrame = Frame(Frame1, width=400, height = 300)           #creates another Frame widget inside Frame1
btnFrame.grid(row=3, column=0, padx=10, pady=2)             #Places the label widget on row 3 of Frame1 grid

#5. Label on top of the Status History Text widget
thirdLabel = Label(Frame1, text="Status History")           #creates third label widget inside Frame1
thirdLabel.grid(row=4, column=0, padx=10, pady=5)           #Places the label widget on row 4 of Frame1 grid

#6 Text widget for logging the history.
LEDLog = Text(Frame1, width = 30, height = 10, takefocus=0) #creates Text widget inside Frame1
LEDLog.grid(row=5, column=0, padx=10, pady=10)              #Places the label widget on row 5 of Frame1 grid
#Widget Ends

#B. Functions for Drawing rectangles inside the canvas widget to represent the pysical status of LED.
def redRectangle():
    rectCanvas.create_rectangle(0, 0, 100, 100, width=0, fill='red')#origin at 0,0(left top) and size of 100x100
    LEDLog.insert(0.0, "On\n")                                  #Insert text inside the LEDLog text widget

def redRectangle_1():
    rectCanvas.create_rectangle(0, 0, 100, 100, width=0, fill='red')

def whiteRectangle():
    rectCanvas.create_rectangle(0, 0, 100, 100, width=0, fill='white')
    LEDLog.insert(0.0, "Off\n")

def whiteRectangle1():
    rectCanvas.create_rectangle(0, 0, 100, 100, width=0, fill='white')

def redRectangle2_2():
    rectCanvas.create_rectangle(0, 0, 100, 100, width=0, fill='red')
    root.after(500, whiteRectangle1)

def redRectangle3_3():
    rectCanvas.create_rectangle(0, 0, 100, 100, width=0, fill='red')
    root.after(500, whiteRectangle1)

def whiteRectangle3_2():
    rectCanvas.create_rectangle(0, 0, 100, 100, width=0, fill='white')
    root.after(300, redRectangle3_3)

def redRectangle3_2():
    rectCanvas.create_rectangle(0, 0, 100, 100, width=0, fill='red')
    root.after(500, whiteRectangle3_2)

def whiteRectangle2_1():
    rectCanvas.create_rectangle(0, 0, 100, 100, width=0, fill='white')
    root.after(350, redRectangle2_2)

def whiteRectangle3_1():
    rectCanvas.create_rectangle(0, 0, 100, 100, width=0, fill='white')
    root.after(350, redRectangle3_2)

def redRectangle1():
    rectCanvas.create_rectangle(0, 0, 100, 100, width=0, fill='red')
    LEDLog.insert(0.0, "1 Blink\n")

def redRectangle2():
    LEDLog.insert(0.0, "2 Blink\n")
    rectCanvas.create_rectangle(0, 0, 100, 100, width=0, fill='red')
    root.after(500, whiteRectangle2_1)

def redRectangle3():
    rectCanvas.create_rectangle(0, 0, 100, 100, width=0, fill='red')
    LEDLog.insert(0.0, "3 Blink\n")
    root.after(500, whiteRectangle3_1)

#Open serial port to the board

ser = serial.Serial('/dev/ttyUSB0', 9600)
time.sleep(1) # waiting for initialising the serial port.
print("Click the buttons on the GUI")

#Function for the buttons
#Turning LED on
def LED1():
    ser = serial.Serial('/dev/ttyUSB0', 9600)
    ser.write('1')
    redRectangle()
def LED2():
    ser = serial.Serial('/dev/ttyUSB0', 9600)
    ser.write('2')
    redRectangle()
def LED3():
    ser = serial.Serial('/dev/ttyUSB0', 9600)
    ser.write('3')
    redRectangle()
def LED4():
    ser = serial.Serial('/dev/ttyUSB0', 9600)
    ser.write('4')
    redRectangle()
def LED5():
    ser = serial.Serial('/dev/ttyUSB0', 9600)
    ser.write('5')
    redRectangle()
def LED6():
    ser = serial.Serial('/dev/ttyUSB0', 9600)
    ser.write('6')
    redRectangle()
def LEDOff():
    ser = serial.Serial('/dev/ttyUSB0', 9600)
    ser.write('7')
    whiteRectangle()

#Buttons

newButton = Button(btnFrame, text="LED1 ON", command=LED1)
newButton.grid(row=0, column=0, padx=10, pady=2)

newButton = Button(btnFrame, text="LED2 ON", command=LED2)
newButton.grid(row=0, column=1, padx=10, pady=2)

newButton = Button(btnFrame, text="LED3 ON", command=LED3)
newButton.grid(row=0, column=2, padx=10, pady=2)

newButton = Button(btnFrame, text="LED4 ON", command=LED4)
newButton.grid(row=0, column=3, padx=10, pady=2)

newButton = Button(btnFrame, text="LED5 ON", command=LED5)
newButton.grid(row=0, column=4, padx=10, pady=2)

newButton = Button(btnFrame, text="LED6 ON", command=LED6)
newButton.grid(row=0, column=5, padx=10, pady=2)

newButton = Button(btnFrame, text="LED Off", command=LEDOff)
newButton.grid(row=0, column=6, padx=10, pady=2)

ser.close() #close serial port

root.mainloop() #loop to update GUI
